#include "kxface.h"

#include <kdebug.h>

#include <qpixmap.h>
#include <qbitmap.h>
#include <qstring.h>
#include <qpainter.h>

#include <stdlib.h>
#include <string.h>

extern "C" {
#include "libcompface/compface.h"
}

QBitmap KXFace::toPixmap(QString ikon)
{
  QBitmap b(48, 48, true);
  QPainter p(&b);
  p.setPen( Qt::color1 );

  ikon = ikon.remove("0x", true);
  ikon = ikon.remove(",", true);
  ikon = ikon.remove("\n", true);
  ikon = ikon.remove(" ", true);
  
  QString tmp = "";
  uint i = 0;
  int pos = 0;
  for(i=0;i<ikon.length();i++)
  {
    tmp = ikon.mid(i, 1);
    if(tmp == "0")
      pos += 4;
    else if (tmp == "1")
    {
      pos += 3;
      p.drawPoint(x(pos), y(pos)); pos++;
    }
    else if (tmp == "2")
    {
      pos += 2;
      p.drawPoint(x(pos), y(pos)); pos++;
      pos++;
    }
    else if (tmp == "3")
    {
      pos += 2;
      p.drawPoint(x(pos), y(pos)); pos++;
      p.drawPoint(x(pos), y(pos)); pos++;
    }
    else if (tmp == "4")
    {
      pos++;
      p.drawPoint(x(pos), y(pos)); pos++;
      pos += 2;
    }
    else if (tmp == "5")
    {
      pos++;
      p.drawPoint(x(pos), y(pos)); pos++;
      pos++;
      p.drawPoint(x(pos), y(pos)); pos++;
    }
    else if (tmp == "6")
    {
      pos++;
      p.drawPoint(x(pos), y(pos)); pos++;
      p.drawPoint(x(pos), y(pos)); pos++;
      pos++;
    }
    else if (tmp == "7")
    {
      pos++;
      p.drawPoint(x(pos), y(pos)); pos++;
      p.drawPoint(x(pos), y(pos)); pos++;
      p.drawPoint(x(pos), y(pos)); pos++;
    }
    else if (tmp == "8")
    {
      p.drawPoint(x(pos), y(pos)); pos++;
      pos += 3;
    }
    else if (tmp == "9")
    {
      p.drawPoint(x(pos), y(pos)); pos++;
      pos += 2;
      p.drawPoint(x(pos), y(pos)); pos++;
    }
    else if (tmp == "a" || tmp == "A")
    {
      p.drawPoint(x(pos), y(pos)); pos++;
      pos++;
      p.drawPoint(x(pos), y(pos)); pos++;
      pos++;
    }
    else if (tmp == "b" || tmp == "B")
    {
      p.drawPoint(x(pos), y(pos)); pos++;
      pos++;
      p.drawPoint(x(pos), y(pos)); pos++;
      p.drawPoint(x(pos), y(pos)); pos++;
    }
    else if (tmp == "c" || tmp == "C")
    {
      p.drawPoint(x(pos), y(pos)); pos++;
      p.drawPoint(x(pos), y(pos)); pos++;
      pos += 2;
    }
    else if (tmp == "d" || tmp == "D")
    {
      p.drawPoint(x(pos), y(pos)); pos++;
      p.drawPoint(x(pos), y(pos)); pos++;
      pos++;
      p.drawPoint(x(pos), y(pos)); pos++;
    }
    else if (tmp == "e" || tmp == "E")
    {
      p.drawPoint(x(pos), y(pos)); pos++;
      p.drawPoint(x(pos), y(pos)); pos++;
      p.drawPoint(x(pos), y(pos)); pos++;
      pos++;
    }
    else if (tmp == "f" || tmp == "F")
    {
      p.drawPoint(x(pos), y(pos)); pos++;
      p.drawPoint(x(pos), y(pos)); pos++;
      p.drawPoint(x(pos), y(pos)); pos++;
      p.drawPoint(x(pos), y(pos)); pos++;
    }
  }
  p.end();
  b.setMask(b);
  //b.save("test.png", "PNG");
  return b;
}

QString KXFace::comp(const QString str)
{
  char *fbuf = (char *)malloc(MAX_XFACE_LENGTH);
  memset(fbuf, '\0', MAX_XFACE_LENGTH);
  strncpy(fbuf, str.latin1(), str.length());
//  printf("%s\n", fbuf);
  compface(fbuf);
//  printf("%s\n", fbuf);
  QString ret(fbuf);
  free(fbuf);
  return ret;
}

QBitmap KXFace::uncomp(const QString str)
{
  if (str.length() > MAX_XFACE_LENGTH)
    return QBitmap();
  
  char *fbuf = (char *)malloc(MAX_XFACE_LENGTH);
  memset(fbuf, '\0', MAX_XFACE_LENGTH);
  strncpy(fbuf, str.latin1(), str.length());
//  printf("%s\n", fbuf);
  uncompface(fbuf);
//  printf("%s\n", fbuf);
  QString ret(fbuf);
  free(fbuf);
  return toPixmap(ret);
}

int KXFace::x(int &pos)
{
  return pos%48;
}

int KXFace::y(int &pos)
{
  return pos/48;
}
